if not _G.DrivingHUD then
	_G.DrivingHUD = {}
	DrivingHUD.loaded_options = {}
	DrivingHUD.mod_path = ModPath
	DrivingHUD.save_path = SavePath
	DrivingHUD.menu_name = "DrivingHUD_options"
	DrivingHUD.write_options = DrivingHUD.write_options or {}
end

DrivingHUD.dofiles = {
	"Options.lua"
}

DrivingHUD.writeoptions = "WriteOptions.lua"

DrivingHUD.hook_files = {
	["lib/managers/hudmanager"] = "HudManager.lua",
	["lib/managers/hudmanagerpd2"] = "HudManagerPD2.lua",
	["lib/states/ingamedriving"] = "IngameDriving.lua",
	["lib/managers/hud/huddriving"] = "HudDriving.lua"
}

if not DrivingHUD.setup then
	for p, d in pairs(DrivingHUD.dofiles) do
		dofile(ModPath .. d)
	end
	DrivingHUD:Load_options()
	DrivingHUD.setup = true
end

if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if DrivingHUD.hook_files[requiredScript] then
		dofile( ModPath .. DrivingHUD.hook_files[requiredScript] )
	end
end

if Hooks then
	--[[Hooks:Add("LocalizationManagerPostInit", "DrivingHUD_Localization", function(loc)
		LocalizationManager:add_localized_strings({
			[""] = ""
			
		})
	end)]]--
	if HUDManager then
		
	end
end

local menu_id = "DrivingHUD_menu" 
Hooks:Add("MenuManagerSetupCustomMenus", "DrivingHUD_SetupCustomMenus", function(menu_manager, nodes)
    MenuHelper:NewMenu( menu_id )
end)

Hooks:Add("MenuManagerBuildCustomMenus", "DrivingHUD_CustomMenus", function(menu_manager, nodes)
    nodes[menu_id] = MenuHelper:BuildMenu( menu_id )
    MenuHelper:AddMenuItem( MenuHelper.menus.lua_mod_options_menu, menu_id, "DrivingHUD", "DrivingHUD_desc", 1 )
	local menu_data = {
		area_bg = "half"
	}

end)

Hooks:Add("MenuManagerPopulateCustomMenus", "DrivingHUD_PopulateCustomMenus", function(menu_manager, nodes)

	MenuCallbackHandler.speed_callback = function(this, item)
		DrivingHUD.loaded_options.speed = item:value() == "on" and true or false
		DrivingHUD:Save()
		IngameDriving:_update_driving_hud()
	end
	
	--MenuCallbackHandler.x_pos_callback = function(this, item)
	--	DrivingHUD.loaded_options.x_pos = item:value()
	--	DrivingHUD:Save()
	--	HUDDriving:update_pos()
	--end
	
	--MenuCallbackHandler.size_callback = function(this, item)
	--	DrivingHUD.loaded_options.size = item:value()
	--	DrivingHUD:Save()
	--end

	MenuHelper:AddToggle({
		id = "speed_option",
		title = "speed",
		desc = "speed_desc",
		callback = "speed_callback",
		value = DrivingHUD.loaded_options.speed,
		menu_id = "DrivingHUD_menu",
		priority = 6,
	})
	

end)

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_LocExample", function(loc)

    loc:add_localized_strings( {
        ["DrivingHUD"] = "DrivingHUD Options",
        ["DrivingHUD_desc"] = "Options for the DrivingHUD",
		["speed"] = "Speed",
		["speed_desc"] = "If selected MPH will be used instead of km/h"
    } )

end)