local lpi_original_hudstatsscreen_show = HUDStatsScreen.show
function HUDStatsScreen:show()
	lpi_original_hudstatsscreen_show(self)

	if LobbyPlayerInfo.settings.show_skills_in_stats_screen then
		local right_panel = managers.hud:script(managers.hud.STATS_SCREEN_FULLSCREEN).panel:child("right_panel")
		if not right_panel then
			return
		end

		local dwp = right_panel:child("day_wrapper_panel")
		if not dwp then
			return
		end

		local dd = dwp:child("day_description")
		dd:set_font_size(12)
		local _, _, _, h = dd:text_rect()
		dd:set_h(h)
		local gt = dwp:child("ghostable_text")
		gt:set_font_size(14)
		gt:set_top(math.round(dd:bottom() + 10))

		local y = math.round(gt:bottom() + 20)
		for i = 1, 4 do
			local peer = managers.network:session():peer(i)
			local txt_name = "lpi_team_text_name" .. tostring(i)
			local name_text = dwp:child(txt_name) or dwp:text({
				name = txt_name,
				text = "A",
				align = "left",
				vertical = "top",
				blend_mode = "add",
				font_size = tweak_data.menu.pd2_small_font_size,
				font = tweak_data.menu.pd2_small_font,
				color = tweak_data.chat_colors[i],
				w = right_panel:w(),
				x = 0,
				y = y
			})
			name_text:set_text(peer and peer:name() or "")

			txt_name = "lpi_team_text_skills" .. tostring(i)
			local skill_text = dwp:child(txt_name) or dwp:text({
				name = txt_name,
				text = "B",
				align = "left",
				vertical = "top",
				blend_mode = "add",
				font_size = tweak_data.menu.pd2_small_font_size - 4,
				font = tweak_data.menu.pd2_small_font,
				color = tweak_data.screen_colors.text,
				w = right_panel:w(),
				x = 10,
				y = y + 20
			})
			local skills_txt = ""
			if peer and peer:skills() then
				local ini_len = LobbyPlayerInfo._abbreviation_length_v
				local ini_mas = utf8.sub(managers.localization:text("st_menu_mastermind"), 1, ini_len)
				local ini_enf = utf8.sub(managers.localization:text("st_menu_enforcer"), 1, ini_len)
				local ini_tec = utf8.sub(managers.localization:text("st_menu_technician"), 1, ini_len)
				local ini_gho = utf8.sub(managers.localization:text("st_menu_ghost"), 1, ini_len)
				local ini_fug = utf8.sub(managers.localization:text("st_menu_hoxton_pack"), 1, ini_len)
				local ppt = LobbyPlayerInfo:GetSkillPointsPerTree(peer:skills():split("-")[1]:split("_"))
				skills_txt = string.format(LobbyPlayerInfo.skills_layouts[1], ini_mas, ppt[1], ini_enf, ppt[2], ini_tec, ppt[3], ini_gho, ppt[4], ini_fug, ppt[5])
			end
			skill_text:set_text(skills_txt)

			txt_name = "lpi_team_text_perk" .. tostring(i)
			local perk_text = dwp:child(txt_name) or dwp:text({
				name = txt_name,
				text = "C",
				align = "left",
				vertical = "top",
				blend_mode = "add",
				font_size = tweak_data.menu.pd2_small_font_size - 4,
				font = tweak_data.menu.pd2_small_font,
				color = tweak_data.screen_colors.text,
				w = right_panel:w(),
				x = 10,
				y = y + 38
			})
			local perk_txt = ""
			if peer and peer:skills() then
				local ps = peer:skills():split("-")[2]:split("_")
				perk_txt = managers.localization:text("menu_st_spec_" .. ps[1]) .. " (" .. ps[2] .. "/9)"
			end
			perk_text:set_text(perk_txt)

			y = math.round(name_text:top() + 60)
		end
	end
end
